<?php
/*********************************************************************************************
	trigger CP_WYSIWYG_image_resize V1.5.2  26.05.09  K.Heermann (flip-flop) http://planmatrix.de

	Since phpwcms V1.4.2 r308 (07.04.2009)
	Based on the new experimental function for using filecenter images with the fck wysiwyg editor. 
	CPs: 1 => textimage, 14 => wysiwyg, 26 => recipe, 32 => tabs
	
	-> http://code.google.com/p/phpwcms/source/detail?r=308
	"FCKEditor got support for phpwcms file browser. Use new setting
	$phpwcms['FCK_FileBrowser'] = 1 in conf.inc.php to enable it (thanks Markus Khl
	<www.pagewerkstatt.ch> for idea and code)."
	-------------
	23.03.09 KH V1.0.0: First script
	25.03.09 KH V1.1.0: Own jpg qualitiy around line 70, error correktion (&amp;q=)-> thanks to claus
	25.03.09 KH V1.2.0: Experimental cmsimage function included (stored img files and crop - better quality)
	27.03.09 KH V1.3.0: Switch in this file: $xlite = switches the LightBox generally to on
	29.03.09 KH V1.4.0: Add: EnlargeIt! for zooming images http://enlargeit.timos-welt.de/english/11/
	30.03.09 KH V1.4.1: Add: EnlargeIt!: group classes for prev/next output. General on switch
	18.04.09 KH V1.4.2: Add: ReMooz: ReMooz (v1.0) http://digitarald.de
	21.04.09 KH V1.5.0: Add: Changeover into a separate file, for a better handling in modules
	21.05.09 KH V1.5.1: Add: Changeover EnlargeIt/ReMooz into separate files. 
	                    Changed ReMooz container from <div .. to <span ... 
	                    (fck-<p><span...> ...</span>:  Only inline elements are allowed inside p tags)
  26.05.09 KH V1.5.1: Add: Generally xnp (next/prev) setup in file direct.
  -------------
	Switches in class name set: 
	  xcrop = crop thumb on| xlight = LightBox on| xnp = nextprev on in LighBox
	  xlight = LightBox on
	  xnolight = LightBox off if LightBox is set generally in this file ($ixlightbox = true;)
	  xremo = ReMooz on
	  xnoremo = ReMooz off if ReMooz is set generally in this file ($ixeremo = true;)

	  xenlarge = EnlargeIt! on
	  xnoenlarge = EnlargeIt! off if EnlargeIt! is set generally in this file ($ixenlargeit = true;)

	  lightbox call switched from filearchive to cmsimage.php function ($cmsimage = true;)
	  (A new image is generated in content/images/)
	
	The height/widht paramters from fck are injected into the used function image_resized.php
	(with jpg quality declared in conf.inc.php)
	
 *********************************************************************************************/
// -------------------------------------------------------------------------------------------
// obligate check for phpwcms constants
  if (!defined('PHPWCMS_ROOT')) {
    die("You Cannot Access This Script Directly, Have a Nice Day."); }
// -------------------------------------------------------------------------------------------


function fck_ximage_resize($text) {

	// ========================================================================
	// Search for all image strings between "<img"       ">"
	   $text = preg_replace_callback("/<img(.*?) \/>/", "my_image_resize" , $text);
	// ========================================================================
	
	// ------------------------------------------------------------------------
	// Only if ReMooz is active: Set a unique container around and a unique addEvent
	// Othewise only one container is possible for all ReMoozed images on the whole site.
	// ------------------------------------------------------------------------
		
	if ( strpos($text, 'rel="remoozboxed"') ) // ReMooz in use? 
		{
		$my_random = substr(md5(microtime()),0,16);  // We need a string for a unique id 
	
	
		$GLOBALS['block']['custom_htmlhead']["remooz_'.$my_random.'"] = '  <script type="text/javascript">

// <![CDATA[
window.addEvent(\'load\', function() {

  ReMooz.assign(\'#my-remooz-image_'.$my_random.' a[rel=remoozboxed]\', {
   \'origin\': \'img\',
   \'resizeFactor\': 0.85, // resize to maximum 85% of screen size
   \'margin\': 20,
   \'dragging\': true, // disable dragging
   \'centered\': false // resize to center of the screen, not relative to the source element
  });
});
   // ]]>

  </script>';
	
	
		$text = '<div id="my-remooz-image_'.$my_random.'">'.$text.'</div>';
	};
	// ---END ReMooz-----------------------------------------------------------
		
	return $text;
}


	// --- Inner function --------------------------------------
	// $img_tag[0] -> Here we admit into a complete string "<img       >" 
	// $img_tag[1] -> is the string between "<img        >"
		function my_image_resize($img_tag) { 
		
		
			if (strpos($img_tag[1],'image_resized.php')) {  // image_resized.php available?
			
				/***********************************************************************
				  Switches for own JPG quaility, generally function call and generally LightBox 
				  - simple image_resized without file storage (low rendered img qualitiy)
				  - img/cmsimage with rendered file stored in content/images/* (better quality)
				 **********************************************************************/
				 // Switch between quality parameter from config or your own one
				    $quality = 85; // default
				 // $my_quality = $GLOBALS['phpwcms']['jpg_quality'];
				
				 // The image quality generated by image_resized is very crappy
				 // Switch between simple image_resized = 0  <-> img/cmsimage = 1
				    $cmsimage = true; 
				    
				 // Using the LightBox generally 
				    $ixlightbox  = false; 
				    
				 // Using the ReMooz generally 
				    $ixremooz    = false; 
				    
				 // Using the EnlargeIt generally 
				    $ixenlargeit = false; 
				    
				 // Using the prev/next feature generally 
				    $ixnp        = false; // available for LightBox and EnlargeIt


				 // Priority 1-LightBox, 2-ReMooz, 3-EnlargeIt
				 // Only one methode is allowed
				    if ($ixlightbox)  {$ixremooz = false; $ixenlargeit = false;}
				      elseif ($ixremooz)  {$ixenlargeit = false; $ixlightbox = false;}
				        elseif ($ixenlargeit)  {$ixremooz = false; $ixlightbox = false;}
				//**********************************************************************
				 // FCK -> images -> enhanced -> style sheet class: 
				 // Classes separated with blanks
				 // - xcrop       = crop thumb on 
				 // - xnp         = nextprev on      // LightBox and EnlargeIt
				 // - xlight      = lightbox on
				 // - xnolight    = lightbox off (if set generally to on)
				 // - xremo       = ReMooz on
				 // - xnoremo     = ReMooz off (if set generally to on)
				 // - xenlarge    = (Optional) EnlargeIt! on
				 // - xnoenlarge  = (Optional) EnlargeIt! off (if set generally to on)

				 
				 // e.g. xcrop xlight        -> using Thumb cropping and LightBox
				 // e.g. xlight xnp          -> using LightBox and the next/prev function 
				 //                             if more then one image available in LightBox (this cp)
				 // e.g. xcrop xenlarge xnp  -> using Thumb cropping, EnlargeIt! and prev/next
				 // e.g. xcrop xremo         -> using Thumb cropping and ReMooz 
				//**********************************************************************

				
				// 1. Dimensions adjusted in fck image attributes:           e.g. height="150" width="200"
				// 2. Dimensions adjusted direct using the computer mouse:   e.g. style="width: 200px; height: 150px;"

				preg_match_all('/((height="|height: )(\d+)("|px))|((width="|width: )(\d+)("|px))|filearchive\/([a-fA-F0-9]{32}).([jJpPeEgGnNiIfF]{3,4})"/', $img_tag[1], $temp); // "fck height/width" search and save in $temp[3]/[7] = value

				// Set search- and replacer
				
//kh		Wird erwartet: <img src="image_resized.php?format=jpg&w=100&h=200&q=85&imgfile=test.jpg" alt="" border="0">
//kh		Alte Version: $search  = '#image_resized\.php\?format\=(.*?)\&amp;q\=(.*?)\&amp;imgfile\=filearchive/(.*?)" #';
				
				$search   = '#image_resized\.php\?format\=(.*?)\&amp;q\=(.*?)\&amp;imgfile\=filearchive/([a-fA-F0-9]{32}).([jJpPeEgGnNiIfF]{3,4})"#';
				$width    = implode($temp[7]);    // FCK image width 
				$height   = implode($temp[3]);    // FCK image height
				$image[1] = implode($temp[9]);    // Filecenter hash name
				$image[2] = implode($temp[10]);   // Filecenter hash extend
	
				$img_wrap  = array();
				$enlargeit  = '';
				$temp       = '';
				
				
				if (empty($cmsimage)) { // using simple image_resized without stored files? 
					$replace = 'image_resized.php?format=$1'.'&amp;w='.$width.'&amp;h='.$height.'&amp;q='.$quality.'&amp;imgfile=filearchive/$3.$4" ';
				} 
				else { // ====== No,we uses cmsimage
				// and there we have some paramaters concealed in class names
					$title  = preg_match('/title\="(.*?)"/i',$img_tag[1], $g) ? html_specialchars($g[1]) : '' ;  // 
					
				// === catch the classes and sort if xnp ist set 
					$class_temp  = preg_match('/class="(.*?)"/i',$img_tag[1], $g) ? trim($g[1]) : '';  // cut out all class names
					$temp = explode(' ', $class_temp);
					$class = '';
					asort($temp);
					
					foreach($temp as $value) 
						$class .= $value.' ';
						
						$xcrop      =  in_array('xcrop',     $temp);
						$xnp        = (in_array('xnp',       $temp) OR $ixnp == true) ? true : false;

						$xlight     =  in_array('xlight',   $temp);
						$xnolight   =  in_array('xnolight', $temp);

						$xremo      =  in_array('xremo',   $temp);  // only if no LightBox and no EnlargeIt
						$xnoremo    =  in_array('xnoremo', $temp);

						$xenlarge   = in_array('xenlarge',   $temp);  // only if no LightBox 
						$xnoenlarge = in_array('xnoenlarge', $temp);

						// Generaly switch over all
						if ($ixlightbox)      {$xlight   = 'xlight'; $xremo = '';      $xenlarge = '';}
						elseif ($ixremooz)    {$xlight   = '';       $xremo = 'xremo'; $xenlarge = ''; $xnp = '';}
						elseif ($ixenlargeit) {$xlight   = '';       $xremo = '';      $xenlarge = 'xenlarge';}


					 // Priority 1-LightBox, 2-ReMooz, 3-EnlargeIt
						if (!empty($xlight)) {$xremo    = ''; $xenlarge = '';}
							elseif (!empty($xremo))  {$xenlarge = ''; $xlight   = '';}
								elseif (!empty($xenlarge)) {$xremo  = ''; $xlight   = '';}

						// Inject into class string in EnlargeIt! section some lines down 

						// ======= cmsimage parameter set
						// get segments: cmsimage.php/%WIDTH%x%HEIGHT%x%CROP%x%QUALITY%/%HASH%.%EXT%
						// by default this should be enough: cmsimage.php/%WIDTH%x%HEIGHT/%HASH%.%EXT% 

						// for lightbox images used from config
						// $phpwcms['img_prev_width']   //max width of the large preview image
						// $phpwcms['img_prev_height']  //max height of the large preview image

						// ====== LIGHTBOX ?? Set in class or generally
//						if ( (!$xnolight) AND ($xlight OR $ixlightbox) ) {
						if ( empty($xnolight) AND (!empty($xlight) OR $ixlightbox) ) {
							$xnextprev = !empty($xnp) ? '[xcpid'.$GLOBALS['crow']['acontent_id'].']' : '';  // next/prev for lightbox?
							
							$img_wrap['begin'] = '<a href="img/cmsimage.php/'.$GLOBALS['phpwcms']['img_prev_width'].'x'.$GLOBALS['phpwcms']['img_prev_height'].'/'.$image[1].'.'.$image[2].'" rel="lightbox'.$xnextprev.'" title="'.$title.'" target="_blank">';
							$img_wrap['end']   = '</a>';

							initializeLightbox();  // start mootools and slimbox
							
						} // LightBox END ======



						// ====== ReMooz available?

						if (file_exists($GLOBALS[basepath].'/template/inc_script/fck_ximage_resize/inc_remooz.php') ) {
						  include $GLOBALS[basepath].'/template/inc_script/fck_ximage_resize/inc_remooz.php'; // this will include a.php
						}
						//  END ReMooz ====== 


						// ====== EnlargeIt available?

						if (file_exists($GLOBALS[basepath].'/template/inc_script/fck_ximage_resize/inc_enlargeit.php') ) {
						  include $GLOBALS[basepath].'/template/inc_script/fck_ximage_resize/inc_enlargeit.php'; // this will include a.php
						}
						// ====== END EnlargeIt 


				// ====== Thumb with width/height and crop from FCK
				//kh Wird erwatet: cmsimage.php/%WIDTH%x%HEIGHT%x%CROP%x%QUALITY%/%HASH%.%EXT%
					$replace = 'img/cmsimage.php/'.$width.'x'.$height.'x'.$xcrop.'x'.$quality.'/$3.$4" '.$enlargeit; 
					
				} // END cms_image

				$img_tag[0] = $img_wrap['begin'] . preg_replace($search, $replace, $img_tag[0]) . $img_wrap['end'];
			} // END my_image_resize
	
			return $img_tag[0];
		}
	// ---------------------------------------------------------


?>